

**************************************************
********** Programs from Clemens et al. **********
**************************************************

cap program drop aidstat
program define aidstat
cap replace gK_gni=gK_gni*100
cap replace gnipcrg=gnipcrg*100
cap replace totfullchg_gain=totfullchg_gain*100
foreach g in gni gdp ODA{
	cap rename EearlyCpro_`g' earlyaidC_`g'
	cap replace earlyaidC_`g'=earlyaidC_`g'*100
	cap gen earlyaidC_`g'2=earlyaidC_`g'^2
	cap replace netoda_`g'=netoda_`g'*100
	cap gen netoda_`g'2=netoda_`g'^2	
	cap replace repay_`g'=repay_`g'*100
	cap gen repay_`g'2=repay_`g'^2
}
cap replace ODA=ODA*100
	cap gen ODA2=ODA^2

end

cap program drop aidstatnoest
program define aidstatnoest
cap replace gK_gni=gK_gni*100
cap replace gnipcrg=gnipcrg*100
cap replace totfullchg_gain=totfullchg_gain*100
foreach g in gni gdp {
	cap rename earlyC_`g' earlyaidC_`g'
	cap replace earlyaidC_`g'=earlyaidC_`g'*100
	cap gen earlyaidC_`g'2=earlyaidC_`g'^2
	cap replace netoda_`g'=netoda_`g'*100
	cap gen netoda_`g'2=netoda_`g'^2
	cap replace repay_`g'=repay_`g'*100
	cap gen repay_`g'2=repay_`g'^2
}
end



cap program drop policyo
program define policyo
	cap drop policy_oldper
	cap drop policy_newper
	cap drop cons
	qui reg gdppcg $bd bdsacw bdinfl bdbb $period if e(sample),vce(cluster ccode)
	gen policy_oldper=bdsacw*_b[bdsacw]+bdinfl*_b[bdinfl]+bdbb*_b[bdbb] if e(sample)
	gen float cons=0
	format cons %20.18f
	foreach var in $bd $period {
		cap sum `var' if e(sample)
		cap replace cons=cons+r(mean)*_b[`var'] if e(sample)
	}
	replace cons=cons+_b[_cons] if e(sample)
	replace policy_oldper=policy_oldper+cons if e(sample)
end

***Adjusted for the use of PPP GDP values from PWT 7.1

cap program drop policyoiv
program define policyoiv
	cap drop policy_oldper
	cap drop policy_newper
	cap drop cons
	qui reg gdppcg bdlgdp $bd bdsacw bdinfl bdbb $period if e(sample),vce(cluster ccode)
	gen policy_oldper=bdsacw*_b[bdsacw]+bdinfl*_b[bdinfl]+bdbb*_b[bdbb] if e(sample)
	gen float cons=0
	format cons %20.18f
	foreach var in bdlgdp $bd $period {
		cap sum `var' if e(sample)
		cap replace cons=cons+r(mean)*_b[`var'] if e(sample)
		}
	replace cons=cons+_b[_cons] if e(sample)
	replace policy_oldper=policy_oldper+cons if e(sample)
end

cap program drop policyn
program define policyn
	cap drop policy_oldper
	cap drop policy_newper
	cap drop cons
	qui reg gdppcg $bd open_ww2 lninfl bbfinal $period if bdsamp==1 ,vce(cluster ccode)
	gen policy_newper=open_ww2*_b[open_ww2]+lninfl*_b[lninfl]+bbfinal*_b[bbfinal] if e(sample)
	gen float cons=0
	format cons %20.18f
	foreach var in $bd $period {
		cap sum `var' if e(sample)
		cap replace cons=cons+r(mean)*_b[`var'] if e(sample)
	}
	replace cons=cons+_b[_cons] if e(sample)
	replace policy_newper=policy_newper+cons if e(sample)
end
	
cap program drop policyniv
program define policyniv
	cap drop policy_oldper
	cap drop policy_newper
	cap drop cons
	qui reg gdppcg  gdppc62_0$bd open_ww2 lninfl bbfinal $period if e(sample),vce(cluster ccode)
	gen policy_newper=open_ww2*_b[open_ww2]+lninfl*_b[lninfl]+bbfinal*_b[bbfinal] if e(sample)
	gen float cons=0
	format cons %20.18f
	foreach var in l.rgdpch  $bd $period {
		cap sum `var' if e(sample)
		cap replace cons=cons+r(mean)*_b[`var'] if e(sample)
	}
	replace cons=cons+_b[_cons] if e(sample)
	replace policy_newper=policy_newper+cons if e(sample)
end

cap program drop policyn62
program define policyn62
	cap drop policy_oldper
	cap drop policy_newper
	cap drop cons
	qui reg gdppcg62 $bd open_ww2 lninfl bbfinal $period if e(sample),vce(cluster ccode)
	gen policy_newper=open_ww2*_b[open_ww2]+lninfl*_b[lninfl]+bbfinal*_b[bbfinal] if e(sample)
	gen float cons=0
	format cons %20.18f
	foreach var in $bd $period {
		cap sum `var' if e(sample)
		cap replace cons=cons+r(mean)*_b[`var'] if e(sample)
	}
	replace cons=cons+_b[_cons] if e(sample)
	replace policy_newper=policy_newper+cons if e(sample)
end

cap program drop policyn62iv
program define policyn62iv
	cap drop policy_oldper
	cap drop policy_newper
	cap drop cons
	qui reg gdppcg62 gdppc62_0 $bd open_ww2 lninfl bbfinal $period if e(sample),vce(cluster ccode)
	gen policy_newper=open_ww2*_b[open_ww2]+lninfl*_b[lninfl]+bbfinal*_b[bbfinal] if e(sample)
	gen float cons=0
	format cons %20.18f
	foreach var in gdppc62_0 $bd $period {
		cap sum `var' if e(sample)
		cap replace cons=cons+r(mean)*_b[`var'] if e(sample)
	}
	replace cons=cons+_b[_cons] if e(sample)
	replace policy_newper=policy_newper+cons if e(sample)
end


cap program drop bdivgeno
program define bdivgeno
	cap drop bdarms1policy bdlgdppolicy bdlgdp2policy bdlpoppolicy bdlpop2policy
	gen bdarms1policy=bdarms1*policy_oldper
	gen bdlgdppolicy=bdlgdp*policy_oldper
	gen bdlgdp2policy=(bdlgdp^2)*policy_oldper
	gen bdlpoppolicy=bdlpop*policy_oldper
	gen bdlpop2policy=(bdlpop^2)*policy_oldper
end

cap program drop bdivgenold
program define bdivgenold
	foreach v in bdarms1policy bdlgdppolicy bdlgdp2policy bdlpoppolicy bdlpop2policy {
		cap drop `v'
	}
	gen bdarms1policy=bdarms1*policy_oldper
	gen bdlgdppolicy=bdlgdp*policy_oldper
	gen bdlgdp2policy=(bdlgdp^2)*policy_oldper
	gen bdlpoppolicy=bdlpop*policy_oldper
	gen bdlpop2policy=(bdlpop^2)*policy_oldper
end


cap program drop bdivgennew
program define bdivgennew
	foreach v in bdarms1policy bdlgdppolicy bdlgdp2policy bdlpoppolicy bdlpop2policy {
		cap drop `v'
	}
	gen bdarms1policy=bdarms1*policy_newper
	gen bdlgdppolicy=bdlgdp*policy_newper
	gen bdlgdp2policy=(bdlgdp^2)*policy_newper
	gen bdlpoppolicy=bdlpop*policy_newper
	gen bdlpop2policy=(bdlpop^2)*policy_newper
end

**************************************************************************************************************************************************************************************
****** Sector disaggregation using the OECD's CRS Data ******************************************************************
***************************************************************************************************************************************************************************************

******************************
** Programm for T-test
capt prog drop sectorttests
*! version 1.0.0  14aug2007  Ben Jann
program sectorttests, eclass
    version 8
	syntax varlist [if] [in], by(varname) [ * ]
    marksample touse
    markout `touse' `by'
    tempname mu_1 mu_2 d d_se d_t d_p
    foreach var of local varlist {
        ttest `var' if `touse', by(`by') `options'
        mat `mu_1' = nullmat(`mu_1'),r(mu_1)
        mat `mu_2' = nullmat(`mu_2'),r(mu_2)
        mat `d'    = nullmat(`d'   ),r(mu_1)-r(mu_2)
        mat `d_se' = nullmat(`d_se'),r(se)
        mat `d_t'  = nullmat(`d_t' ),r(t)
        mat `d_p'  = nullmat(`d_p' ),r(p)
    }
    foreach mat in mu_1 mu_2 d d_se d_t d_p {
        mat coln ``mat'' = `varlist'
    }
    tempname b V
    mat `b' = `mu_1'*0
    mat `V' = `b''*`b'
    eret post `b' `V'
    eret local cmd "ttest"
    foreach mat in mu_1 mu_2 d d_se d_t d_p {
        eret mat `mat' = ``mat''
    }
end

use "data processed\CRSaid_unsc.dta", clear
cap program drop sectoral
program define sectoral
destring Sector2digit, gen(sector2digit) /* purpose code of CRS Data */
drop if unsc==.
* Descriptive Statistics
by unsc, sort : tabstat usd_commitment_defl, statistics( mean var range ) by(sector2digit)
by unsc, sort : tabstat usd_commitment, statistics( mean var range ) by(sector2digit)
by unsc, sort : tabstat usd_disbursement_defl, statistics( mean var range ) by(sector2digit)
by unsc, sort : tabstat usd_disbursement, statistics( mean var range ) by(sector2digit)
by unsc, sort : tabstat usd_received, statistics( mean var range ) by(sector2digit)
by unsc, sort : tabstat usd_received_defl, statistics( mean var range ) by(sector2digit)


levelsof sector2digit, local(levels)
foreach l of local levels {
gen usd_commitment_defl_`l'=.
replace usd_commitment_defl_`l'=usd_commitment_defl if sector2digit==`l'
}
label var usd_commitment_defl_11 "Education"
label var usd_commitment_defl_12 "Health"
label var usd_commitment_defl_13 "Population"
label var usd_commitment_defl_14 "Water and Sanitation"
label var usd_commitment_defl_15 "Government /Civil Society"
label var usd_commitment_defl_16 "Other Social Infrastructure and Services"
label var usd_commitment_defl_21 "Transport and Storage"
label var usd_commitment_defl_22 "Communication"
label var usd_commitment_defl_23 "Energy Generation and Supply"
label var usd_commitment_defl_24 "Banking and Financial Services"
label var usd_commitment_defl_25 "Busines and other Services"
label var usd_commitment_defl_31 "Agriculture/Fishing"
label var usd_commitment_defl_32 "Industry/Mining"
label var usd_commitment_defl_33 "Trade/Tourism"
label var usd_commitment_defl_41 "Environment"
label var usd_commitment_defl_43 "Other multisector"
label var usd_commitment_defl_51 "General budget support" 
label var usd_commitment_defl_52 "Food aid"
label var usd_commitment_defl_53 "Other commodity assistance"
label var usd_commitment_defl_60 "Debt"
label var usd_commitment_defl_72 "Emergency Response"
label var usd_commitment_defl_73 "Reconstruction relief"
label var usd_commitment_defl_74 "Disaster prevention"
label var usd_commitment_defl_91 "admin of donors" 
label var usd_commitment_defl_93 "Refugees"
label var usd_commitment_defl_99 "Unspecified" 

levelsof sector2digit, local(levels)
* Table for simple T-Test
local append replace
local first 11
foreach l of local levels  {
* simple T-Test
sectorttests usd_commitment_defl_`l' if sector2digit==`l', by(unsc)
ereturn list
estout using "tables\Aid by sector.txt", `append'  ///
    cells("mu_1(fmt(a3) label(NoUNSC mean)) mu_2 (label(UNSC mean)) d(label(t-test means)) d_p(label(p-Value)) ") ///
	 label `title'
	 if `l'==11 local append append
}

drop usd_commitment_defl_*



********
use "data processed\CRSaidtype_unsc.dta", clear
set more off
* relevant codes
label var aid_t "Type of aid"
gen Budget=.
replace Budget=1 if aid_t=="A01" | aid_t=="A02"
replace Budget=0 if aid_t=="C01" // Budget equals 1 if it is budget aid, 0 if it is project aid and . otherwise
bys recipientcode year Budget: gen count=[_n]
bysort recipientcode year: egen budget_usd_commitment_defl=sum(usd_commitment_defl) if Budget==1
bysort recipientcode year: egen project_usd_commitment_defl=sum(usd_commitment_defl) if Budget==0
drop if Budget==.
/*
foreach var in usd_commitment_defl  {
bysort recipientcode year: egen tot`var'=sum(`var')
bys recipientcode year: gen Budget_`var'=budget_`var'/tot`var'
bys recipientcode year: gen Project_`var'=project_`var'/tot`var'
}*/
keep if count==1

** Tests for mean change in Budget and Project aid
local append replace
local title title("T-Test for budget vs project aid") 
local first usd_commitment_defl
*** Budget aid
sectorttests budget_usd_commitment_defl, by(unsc)
ereturn list
estout using "tables\Budget and Project aid.txt", `append'  ///
    cells("mu_1(fmt(a3) label(NoUNSC  mean)) mu_2 (label(UNSC  mean)) d(label(Difference)) d_p(label(p-Value))")  ///
	 `title' label 

*** Project aid
sectorttests project_usd_commitment_defl, by(unsc)
ereturn list
estout using "tables\Budget and Project aid.txt", append  ///
    cells("mu_1(fmt(a3) label(NoUNSC mean)) mu_2 (label(UNSC mean)) d(label(Difference)) d_p(label(p-Value))")  ///
	 label 

***************************************
* Tied aid vs. untied aid
use "data processed/CRS_tiedaid.dta", clear
set more off
bysort recipientcode year: gen totAid_defl=usd_amounttied_defl + usd_amountuntied_defl + usd_amountpartialtied_defl
gen untied=usd_amountuntied_defl+usd_amountpartialtied_defl
local append replace
local title title("Tests for tied aid") 
local first usd_amounttied_defl

foreach var in usd_amounttied_defl usd_amountpartialtied_defl usd_amountuntied_defl   {
sectorttests `var', by(unsc)
ereturn list
estout using "tables\Tied aid.txt", `append'  ///
    cells("mu_1(fmt(a3) label(NoUNSC mean)) mu_2 (label(UNSC mean)) d(label(Difference)) d_p(label(p-Value)) ") ///
	 `title' label 
if `var'==usd_amounttied_defl local append append
if `var'==usd_amounttied_defl local title mlabels(none)
}


***************************************
** Grants vs. loans
** Look at Type of Finance: variable is "finance_t"
use "data processed/CRSfinancetype_unsc.dta", clear
set more off
gen grant=.
replace grant=1 if finance2digit==11
label var grant "Finance-Type Grant"
gen loan=.
replace loan=1 if finance2digit==41
label var loan "Finance-Type Loan"

foreach l in grant loan {
gen usd_commitment_defl_`l'=.
}
replace usd_commitment_defl_grant=usd_commitment_defl if finance2digit==11
replace usd_commitment_defl_loan=usd_commitment_defl if finance2digit==41

* Table for simple T-Test
local append replace
local title title("T-Test for loans vs. grants, `var'") 
local first grant
foreach l in grant loan  {
* simple T-Test
sectorttests usd_commitment_defl_`l' , by(unsc)
ereturn list
estout using "tables\Loans and grants.txt", `append'  ///
    cells("mu_1(fmt(a3) label(NoUNSC mean)) mu_2 (label(UNSC mean)) d(label(Difference)) d_p(label(p-Value)) ") ///
	 label `title'
	 if `l'==1 local append append
	 if `l'==1 local title mlabels(none)
}


end



